=== debian/changelog ===
minetest (0.4.11+repack-1) experimental; urgency=medium

  * Upload to experimental.
  * Imported Upstream version 0.4.11+repack. (Closes: #774662)
  * Add myself to Uploaders.
  * debian/control:
    - Add libx11-dev to Build-Depends to prevent a FTBFS.
    - Use shorter Vcs-Browser URI.
  * Rebase hurd.patch.
  * Add *.patch extension to all patch files.
  * Update DEP3 patch headers and remove jthread-changed.patch because
    it was not applied anyway.
  * Update useless-depends.patch.
    Readd X11 library otherwise the build will fail due to missing symbols.
  * minetest-server.service: Restart server unit on-failure.
  * Export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed to avoid useless
    dependencies.
  * Add desktop-file.patch and hyphen-used-as-minus.patch.
    Add keywords to desktop file and fix lintian warning hyphen-used-as-minus
    sign.
  * debian/upstream.changelog: Just point to upstream's wiki for retrieving the
    latest changelog.
  * Update debian/copyright for new release and use a more permissible license
    for debian/patches/.
  * debian/rules: Enable verbose Makefile to detect possible compilation
    issues.

 -- Markus Koschany <apo@gambaru.de>  Mon, 05 Jan 2015 20:45:10 +0100
