## minetest 0.4.12%2brepack

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,10 +4,26 @@
 INCLUDE(CheckCSourceRuns)
 INCLUDE(CheckIncludeFiles)
 
+# Add custom SemiDebug build mode
+set(CMAKE_CXX_FLAGS_SEMIDEBUG "-O1 -g -Wall -Wabi" CACHE STRING
+	"Flags used by the C++ compiler during semidebug builds."
+	FORCE
+)
+set(CMAKE_C_FLAGS_SEMIDEBUG "-O1 -g -Wall -pedantic" CACHE STRING
+	"Flags used by the C compiler during semidebug builds."
+	FORCE
+)
+mark_as_advanced(
+	CMAKE_CXX_FLAGS_SEMIDEBUG
+	CMAKE_C_FLAGS_SEMIDEBUG
+)
+set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
+	"Choose the type of build. Options are: None Debug SemiDebug RelWithDebInfo MinSizeRel."
+	FORCE
+)
+
 # Set some random things default to not being visible in the GUI
 mark_as_advanced(EXECUTABLE_OUTPUT_PATH LIBRARY_OUTPUT_PATH)
-mark_as_advanced(SQLITE3_INCLUDE_DIR SQLITE3_LIBRARY)
-mark_as_advanced(JSON_INCLUDE_DIR JSON_LIBRARY)
 
 option(ENABLE_CURL "Enable cURL support for fetching media" 1)
 
@@ -112,6 +128,7 @@
 if(WIN32)
 	# Windows
 	if(MSVC) # MSVC Specifics
+		set(PLATFORM_LIBS dbghelp.lib ${PLATFORM_LIBS})
 		# Surpress some useless warnings
 		add_definitions ( /D "_CRT_SECURE_NO_DEPRECATE" /W1 )
 	else() # Probably MinGW = GCC
@@ -174,7 +191,7 @@
 	set(CLIENT_PLATFORM_LIBS ${CLIENT_PLATFORM_LIBS} ${XXF86VM_LIBRARY})
 endif()
 
-find_package(Sqlite3 REQUIRED)
+find_package(SQLite3 REQUIRED)
 find_package(Json REQUIRED)
 
 option(ENABLE_GLES "Enable OpenGL ES support" 0)
@@ -297,7 +314,7 @@
 
 set(USE_REDIS 0)
 
-OPTION(ENABLE_REDIS "Enable redis backend" 1)
+OPTION(ENABLE_REDIS "Enable redis backend" 0)
 
 if(ENABLE_REDIS)
 	find_library(REDIS_LIBRARY hiredis)
@@ -390,32 +407,3 @@
 	nodetimer.cpp
 	noise.cpp
 	object_properties.cpp
-	pathfinder.cpp
-	player.cpp
-	porting.cpp
-	quicktune.cpp
-	rollback.cpp
-	rollback_interface.cpp
-	serialization.cpp
-	server.cpp
-	serverlist.cpp
-	serverobject.cpp
-	settings.cpp
-	sha1.cpp
-	socket.cpp
-	sound.cpp
-	staticobject.cpp
-	subgame.cpp
-	test.cpp
-	tool.cpp
-	treegen.cpp
-	version.cpp
-	voxel.cpp
-	voxelalgorithms.cpp
-	${JTHREAD_SRCS}
-	${common_SCRIPT_SRCS}
-	${UTIL_SRCS}
-)
-
-# This gives us the icon and file version information
-if(WIN32)
